<?php

namespace Teknisa\CADFIN\Controllers;

use Teknisa\CADFIN\Services\Bco51100TipodeDebitoBancarioService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Response\Error; 

use Teknisa\CADFIN\Controllers\TeknisaCrud;

class Bco51100TipodeDebitoBancarioController extends TeknisaCrud {
    protected $dataSourceName = "tpdebibanc";
    protected $parameterBagColumns = array('NRORG');
    
    public function __construct($crudService, ParameterBag $parameterBag, Bco51100TipodeDebitoBancarioService $service) {
        $this->service = $service;
        parent::__construct($crudService, $parameterBag);
    }
    
    public function validarCodigo(DTO\Request\Row $request, DTO\Response $response){
        try{
            $this->service->validarCodigo($request->getRow());
        }
        catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
}