<?php
namespace Teknisa\CADFIN\Controllers;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Teknisa\Libs\Util\Environment;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request\Row as Row;
use Teknisa\CADFIN\Services\Ger70000TipoDePagamentoService;

class Ger70000TipoDePagamentoController {
    protected $environment;
     
    public function __construct(Environment $environment, $Ger70000TipoDePagamentoService) {
        $this->environment   = $environment;
        $this->Ger70000TipoDePagamentoService = $Ger70000TipoDePagamentoService;
    }
    
    
    public function saveTipPag(Row $row, Response $response) {
        $row = $row->getRow();
        if($row['__is_new'] === true){
            $result = $this->Ger70000TipoDePagamentoService->saveTipPag($row);
            $response->addDataSet(new DataSet('tipoDePagamento', ['success' => 'Salvo com sucesso!']));
        }else{
            $this->Ger70000TipoDePagamentoService->updateTipPag($row);
            $response->addDataSet(new DataSet('tipoDePagamento', ['success' => 'Atualizado com sucesso!']));
        }
            
   	}
   	
    public function deleteTipPag(Row $row, Response $response) {
        $row  = $row->getRow();
        $this->Ger70000TipoDePagamentoService->deleteTipPag($row);
        $response->addDataSet(new DataSet('tipoDePagamento', ['success' => 'S']));
   	}
}