<?php

namespace Teknisa\CADFIN\Controllers;

use Teknisa\CADFIN\Services\Bco51100TipodeDebitoBancarioService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\CADFIN\Controllers\TeknisaCrud;

class GeralpagTipoajpagarController extends TeknisaCrud {
    protected $dataSourceName = "geralpag_tipoajpagar_tipobaixapag_tpcredbanc";
    protected $connection;
    protected $newCode;

    public function __construct($crudService, $parameterBag, $entityManager, $newCode,$environment) {
        $this->environment = $environment;
		parent::__construct($crudService, $parameterBag);
		$this->newCode = $newCode;
		$this->connection = $entityManager->getConnection();
		$this->entityManager    = $entityManager;
	}

    public function save(DTO\Request $request, DTO\Response $response){

    	$dataSet = $request->getDataSet();
    	$rows = $dataSet->getRows();
    	
    	$rowGeralRec = $rows[0];

		$method = $request->getMethod();
        $routePath = $request->getRoutePath();
        $userId = $request->getUserId();

    	$this->connection->beginTransaction();

    	try{
    	     if ($rowGeralRec['__is_new']) {
    	         
    	         $paramsGeralPag = array(
    	             "CDGERALPAG" => '1',
    	             "CDAJMULTAPAG" => $rowGeralRec["CDAJMULTAPAG"],
    	             "CDAJMORAPAG" => $rowGeralRec["CDAJMORAPAG"],
    	             "CDAJACREPAG" => $rowGeralRec["CDAJACREPAG"],
    	             "CDAJDESCPAG" => $rowGeralRec["CDAJDESCPAG"],
                     "CDTPBXANTAUTO" => isset($rowGeralRec["CDTPBXANTAUTO"])?$rowGeralRec["CDTPBXANTAUTO"]:null,
                     "CDAJUANTAUTO" => $rowGeralRec["CDAJUANTAUTO"],
                     "CDTPBXCREDCONT" => $rowGeralRec["CDTPBXCREDCONT"],
                     "CDTPBAIXADOC" => $rowGeralRec["CDTPBAIXADOC"],
                     "CDTPBAIXATED"  => $rowGeralRec["CDTPBAIXATED"],
                     "IDHABIBOLE" => $rowGeralRec["IDHABIBOLE"],
                     "CDSERIEENTRSAG" => $rowGeralRec["CDSERIEENTRSAG"],
                     "CDFORNECEDSAG" => $rowGeralRec["CDFORNECEDSAG"],
                     "CDTIPOOPERSAG" => $rowGeralRec["CDTIPOOPERSAG"],
                     "CDTPCTPAGARSAG" => $rowGeralRec["CDTPCTPAGARSAG"],
                     "IDUTILPADRBOLHAB" => $rowGeralRec["IDUTILPADRBOLHAB"],
                     "IDUTIAUTDESP" => $rowGeralRec["IDUTIAUTDESP"],
                     "IDEXTELACALAJUBX" => $rowGeralRec["IDEXTELACALAJUBX"],
                     "CDTPCREDESTBANC" =>$rowGeralRec["CDTPCREDESTBANC"],
                     "IDUTLNFDEVOL" =>  $rowGeralRec["IDUTLNFDEVOL"],
                     "IDUTVISUBOLOPEL" => $rowGeralRec["IDUTVISUBOLOPEL"],
                     "CDOPEPERVISUBOL" => $rowGeralRec["CDOPEPERVISUBOL"],
                     "QTDIAANTBAIP" =>  intVal($rowGeralRec["QTDIAANTBAIP"]),
                     "QTDIAAPOBAIP" => intVal($rowGeralRec["QTDIAAPOBAIP"]),
                     "QTDIAANTBOLP" => intVal($rowGeralRec["QTDIAANTBOLP"]),
                     "QTDIAANTLANP" => intVal($rowGeralRec["QTDIAANTLANP"]),
                     "QTDIAAPOLANP" => intVal($rowGeralRec["QTDIAAPOLANP"]),
                     "QTDIAAPOBOLP" => intVal($rowGeralRec["QTDIAAPOBOLP"]),
                     "NRORG" => $this->environment->getNrOrgTrab()
    	       );
    	         
    	       $this->insereParametroContaPagar($paramsGeralPag);

    	     } else {
    	       //  
    	       $paramsGeralPag = array(
    	             "CDGERALPAG" => '1',
    	             "CDAJMULTAPAG" => $rowGeralRec["CDAJMULTAPAG"],
    	             "CDAJMORAPAG" => $rowGeralRec["CDAJMORAPAG"],
    	             "CDAJACREPAG" => $rowGeralRec["CDAJACREPAG"],
    	             "CDAJDESCPAG" => $rowGeralRec["CDAJDESCPAG"],
                     "CDTPBXANTAUTO" => isset($rowGeralRec["CDTPBXANTAUTO"])?$rowGeralRec["CDTPBXANTAUTO"]:null ,
                     "CDAJUANTAUTO" => $rowGeralRec["CDAJUANTAUTO"],
                     "CDTPBXCREDCONT" => $rowGeralRec["CDTPBXCREDCONT"],
                     "CDTPBAIXADOC" => $rowGeralRec["CDTPBAIXADOC"],
                     "CDTPBAIXATED" => $rowGeralRec["CDTPBAIXATED"],
                     "IDHABIBOLE" => $rowGeralRec["IDHABIBOLE"],
                     "CDSERIEENTRSAG" => $rowGeralRec["CDSERIEENTRSAG"],
                     "CDFORNECEDSAG" => $rowGeralRec["CDFORNECEDSAG"],
                     "CDTIPOOPERSAG" => $rowGeralRec["CDTIPOOPERSAG"],
                     "CDTPCTPAGARSAG" => $rowGeralRec["CDTPCTPAGARSAG"],
                     "IDUTILPADRBOLHAB" => $rowGeralRec["IDUTILPADRBOLHAB"],
                     "IDUTIAUTDESP" => $rowGeralRec["IDUTIAUTDESP"],
                     "IDEXTELACALAJUBX" => $rowGeralRec["IDEXTELACALAJUBX"],
                     "CDTPCREDESTBANC" =>$rowGeralRec["CDTPCREDESTBANC"],
                     "IDUTLNFDEVOL" =>  $rowGeralRec["IDUTLNFDEVOL"],
                     "IDUTVISUBOLOPEL" => $rowGeralRec["IDUTVISUBOLOPEL"],
                     "CDOPEPERVISUBOL" => $rowGeralRec["CDOPEPERVISUBOL"],
                     "QTDIAANTBAIP" =>  intVal($rowGeralRec["QTDIAANTBAIP"]),
                     "QTDIAAPOBAIP" => intVal($rowGeralRec["QTDIAAPOBAIP"]),
                     "QTDIAANTBOLP" => intVal($rowGeralRec["QTDIAANTBOLP"]),
                     "QTDIAANTLANP" => intVal($rowGeralRec["QTDIAANTLANP"]),
                     "QTDIAAPOLANP" => intVal($rowGeralRec["QTDIAAPOLANP"]),
                     "QTDIAAPOBOLP" => intVal($rowGeralRec["QTDIAAPOBOLP"])
    	       );
    	       $this->atualizaRegistro($paramsGeralPag);
    	     }

    	     $this->connection->commit();
    	    
		} catch (\Exception $e){
			$response->setError(new Error($e->getMessage(), 500));
			$this->connection->rollBack();
		}
    }

    public function saveRow($row, $dataSourceName, $method, $routePath, $userId, $response){
    	$request = $this->buildResquest($row, $dataSourceName, $method, $routePath, $userId);
    	$this->dataSourceName = $dataSourceName;
    	parent::save($request, $response);
    	//$this->dataSourceName = 'geralrec_tipoajreceber';
    }

    public function buildResquest($row, $dataSourceName, $method, $routePath, $userId){
        $dataSet = new DataSet($dataSourceName, array($row));
        $request = new DTO\Request\DataSet($dataSet, $method, $routePath, $userId);
        return $request;
    }

    public function saveTabedsOperadores(DTO\Request $request, DTO\Response $response) {
     try{
        
        $dataSet = $request->getDataSet();
        $rows = $dataSet->getRows();
        
        $this->saveOperadores($rows);
        $response->addDataSet(new DataSet('retorno', array('success' => 'S')));

     } catch (\Exception $e){
       $response->setError(new Error($e->getMessage(), 500));
     }
   }


    public function atualizaTabelaParamGeral($params){

        $sql = "UPDATE PARAMGERAL SET IDUTLPROCPAG =:IDUTLPROCPAG,
                                      CDGROPERPROP =:CDGROPERPROP
                WHERE CDPARGERAL =:CDPARGERAL";
        $std = $this->connection->prepare($sql);
        $std->execute($params);

    }
    
    public function atualizaTabelaGeralPag($params){

        $sql = "UPDATE GERAL_PAG SET IDBLOQINCNTP =:IDBLOQINCNTP,
                                     CDGROPERCNTP =:CDGROPERCNTP,
                                     IDTPCNTPLIB =:IDTPCNTPLIB,
                                     IDUTLPRORVCPAG =:IDUTLPRORVCPAG,
                                     IDUTCTRLCANREMP =:IDUTCTRLCANREMP,
                                     CDGERALPAG =:CDGERALPAG
                WHERE CDGERALPAG =:CDGERALPAG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
    }

    public function saveOperadores($row){

        try{
            
            $paramsGeralPag = array(
                "IDBLOQINCNTP" => $row[0]["IDBLOQINCNTP"],
                "CDGROPERCNTP" => $row[0]["CDGROPERCNTP"],
                "IDTPCNTPLIB" => $row[0]["IDTPCNTPLIB"],
                "IDUTLPRORVCPAG" => isset($row[0]["IDUTLPRORVCPAG"])?$row[0]["IDUTLPRORVCPAG"]:"N",
                "IDUTCTRLCANREMP" => isset($row[0]["IDUTCTRLCANREMP"])?$row[0]["IDUTCTRLCANREMP"]:"N",
                "CDGERALPAG" => 1
            );
            // var_dump($row[0]); die;
            $this->atualizaTabelaGeralPag($paramsGeralPag);
            
            $paramsParamGeral = array(
                "CDGROPERPROP"=> $row[0]["CDGROPERPROP"],
                "IDUTLPROCPAG"=> $row[0]["IDUTLPROCPAG"],
                "CDPARGERAL" => "0001"
            );
            
            $this->atualizaTabelaParamGeral($paramsParamGeral);
                if(empty($row[0]["CDGRUPOPERPRVC"])) {
                    $idautgrupop = 'PRVC';
                    $verificaOperadoresInseridos = $this->verificaOperadoresInseridos($idautgrupop);
    
                    foreach($verificaOperadoresInseridos as $dados){
                        $param =  array(
                            "CDGRUPOPER" => $dados["CDGRUPOPER"]
                        );
                        $this->removeGrupoOperadores($param);
                    }
                } else {
    
                    // Adiciona ou remove (Grupo de Operadores) referente a Controla Prorrogacao de Vencimento
                    $idautgrupop = 'PRVC';
                    $verificaOperadoresInseridos = $this->verificaOperadoresInseridos($idautgrupop);
                    $operadoresExistentes = array();

                    if(!is_array($row[0]["CDGRUPOPERPRVC"])){
                        $row[0]["CDGRUPOPERPRVC"] = array($row[0]["CDGRUPOPERPRVC"]);
                    }
    
                    foreach($verificaOperadoresInseridos as $dados){
                        array_push($operadoresExistentes, $dados["CDGRUPOPER"]);
                        if(!in_array($dados["CDGRUPOPER"],$row[0]["CDGRUPOPERPRVC"])){
                            $param =  array(
                                "CDGRUPOPER" => $dados["CDGRUPOPER"]
                            );
                            $this->removeGrupoOperadores($param);
                        }
                    }
    
                    $nrautgrupop = $this->newCode->getCodeByTableName('AUTGRUPOP',$this->environment->getNrOrgTrab());
    
                    foreach ($row[0]["CDGRUPOPERPRVC"] as $indiceContPross) {
                        if(!in_array($indiceContPross,$operadoresExistentes)){
                            if(empty($verificaOperadoresInseridos)){
                                $dados = array(
                                  "CDGRUPOPER" => $indiceContPross,
                                  "IDAUTGRUPOP" => "PRVC",
                                  "NRAUTGRUPOP" => substr($nrautgrupop, -3)
                                );
                                $this->insereAutoGroupPop($dados);
    
                            } else {
                                $dados = array(
                                  "CDGRUPOPER" => $indiceContPross,
                                  "IDAUTGRUPOP" => "PRVC",
                                  "NRAUTGRUPOP" => $verificaOperadoresInseridos[0]["NRAUTGRUPOP"]
                                );
                                $this->insereAutoGroupPop($dados);
                            }
    
                        }
                    }
                }
    
                if(empty($row[0]["CDGRUPOPEREXBP"])){
    
                    $idautgrupop = 'EXBP';
                    $verificaOperadoresExclusaoBaixa = $this->verificaOperadoresInseridos($idautgrupop);
    
                    foreach($verificaOperadoresExclusaoBaixa as $dados){
                        $param =  array(
                            "CDGRUPOPER" => $dados["CDGRUPOPER"]
                        );
                        $this->removeGrupoOperadores($param);
                    }
    
                } else {
                    // Adiciona ou remove (Grupo de Operadores) referente a Controla Exclusao de Baixa (Recebimento)
                    $idautgrupop = 'EXBP';
                    $verificaOperadoresExclusaoBaixa = $this->verificaOperadoresInseridos($idautgrupop);
                    $operadoresExclusaoBaixa = array();
    
                    foreach($verificaOperadoresExclusaoBaixa as $dados){
                        array_push($operadoresExclusaoBaixa, $dados["CDGRUPOPER"]);
                        if(!in_array($dados["CDGRUPOPER"],$row[0]["CDGRUPOPEREXBP"])){
                            $param =  array(
                                "CDGRUPOPER" => $dados["CDGRUPOPER"]
                            );
                            $this->removeGrupoOperadores($param);
                        }
                    }
    
                    $nrautgrupop = $this->newCode->getCodeByTableName('AUTGRUPOP',$this->environment->getNrOrgTrab());
                    foreach ($row[0]["CDGRUPOPEREXBP"] as $indiceExcBaixa) {
                        if(!in_array($indiceExcBaixa,$operadoresExclusaoBaixa)){
                            if(empty($verificaOperadoresExclusaoBaixa)){
                                $dados = array(
                                  "CDGRUPOPER" => $indiceExcBaixa,
                                  "IDAUTGRUPOP" => "EXBP",
                                  "NRAUTGRUPOP" =>  substr($nrautgrupop, -3)
                                );
                                $this->insereAutoGroupPop($dados);
    
                            } else {
                                $dados = array(
                                  "CDGRUPOPER" => $indiceExcBaixa,
                                  "IDAUTGRUPOP" => "EXBP",
                                  "NRAUTGRUPOP" => $verificaOperadoresExclusaoBaixa[0]["NRAUTGRUPOP"]
                                );
                                $this->insereAutoGroupPop($dados);
                            }
    
                        }
                    }
                }
    
                if(empty($row[0]["CDGRUPOPERCRMP"])){
    
                    $idautgrupop = 'CRMP';
                    $verificaOperadoresRemessaBoleto = $this->verificaOperadoresInseridos($idautgrupop);
    
                    foreach($verificaOperadoresRemessaBoleto as $dados){
                        $param =  array(
                            "CDGRUPOPER" => $dados["CDGRUPOPER"]
                        );
                        $this->removeGrupoOperadores($param);
                    }
    
                } else {
    
                    // Adiciona ou remove (Grupo de Operadores) referente a Controla Cancelamento de Remessa de Boleto
                    $idautgrupop = 'CRMP';
                    $verificaOperadoresRemessaBoleto = $this->verificaOperadoresInseridos($idautgrupop);
                    $operadoresRemessaBoleto = array();
    
                    foreach($verificaOperadoresRemessaBoleto as $dados){
                        array_push($operadoresRemessaBoleto, $dados["CDGRUPOPER"]);
                        if(!in_array($dados["CDGRUPOPER"],$row[0]["CDGRUPOPERCRMP"])){
                            $param =  array(
                                "CDGRUPOPER" => $dados["CDGRUPOPER"]
                            );
                            $this->removeGrupoOperadores($param);
                        }
                    }
    
                    $nrautgrupop = $this->newCode->getCodeByTableName('AUTGRUPOP',$this->environment->getNrOrgTrab());
                    foreach ($row[0]["CDGRUPOPERCRMP"] as $indiceRemBoleto) {
                        if(!in_array($indiceRemBoleto,$operadoresRemessaBoleto)){
                            if(empty($verificaOperadoresRemessaBoleto)){
                                $dados = array(
                                  "CDGRUPOPER" => $indiceRemBoleto,
                                  "IDAUTGRUPOP" => "CRMP",
                                  "NRAUTGRUPOP" => substr($nrautgrupop, -3)
                                );
                                $this->insereAutoGroupPop($dados);
                            } else{
                                $dados = array(
                                  "CDGRUPOPER" => $indiceRemBoleto,
                                  "IDAUTGRUPOP" => "CRMP",
                                  "NRAUTGRUPOP" => $verificaOperadoresRemessaBoleto[0]["NRAUTGRUPOP"]
                                );
                                $this->insereAutoGroupPop($dados);
                            }
                        }
                    }
                }
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function verificaOperadoresInseridos($idautgrupop){

        $sql = "SELECT A.CDGRUPOPER, A.NRAUTGRUPOP
                  FROM AUTGRUPOP A
                 WHERE  A.IDAUTGRUPOP =  '$idautgrupop'";
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }

    public function insereAutoGroupPop($dados){
        $sql = "INSERT INTO AUTGRUPOP (CDGRUPOPER, IDAUTGRUPOP, NRAUTGRUPOP)
                            VALUES(:CDGRUPOPER, :IDAUTGRUPOP,:NRAUTGRUPOP)";
        $std = $this->connection->prepare($sql);
        $std->execute($dados);
    }

    public function removeGrupoOperadores($param){

        $sql = "DELETE FROM AUTGRUPOP
                WHERE  CDGRUPOPER =: CDGRUPOPER";
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
    
    public function insereParametroContaPagar($paramsGeralPag){
        
            $sql = "INSERT INTO GERAL_PAG (CDGERALPAG,CDAJMULTAPAG,CDAJMORAPAG,CDAJACREPAG,
                                            CDAJDESCPAG,CDTPBXANTAUTO,CDAJUANTAUTO,CDTPBXCREDCONT,
                                            CDTPBAIXADOC,CDTPBAIXATED,IDHABIBOLE,CDSERIEENTRSAG,
                                            CDFORNECEDSAG,CDTIPOOPERSAG,CDTPCTPAGARSAG,IDUTILPADRBOLHAB,
                                            IDUTIAUTDESP,IDEXTELACALAJUBX,CDTPCREDESTBANC,IDUTLNFDEVOL,
                                            IDUTVISUBOLOPEL,CDOPEPERVISUBOL,QTDIAANTBAIP,QTDIAAPOBAIP,
                                            QTDIAANTBOLP,QTDIAANTLANP,QTDIAAPOLANP,QTDIAAPOBOLP,NRORG)
                     VALUES(:CDGERALPAG,:CDAJMULTAPAG,:CDAJMORAPAG,:CDAJACREPAG,
                                            :CDAJDESCPAG,:CDTPBXANTAUTO,:CDAJUANTAUTO,:CDTPBXCREDCONT,
                                            :CDTPBAIXADOC,:CDTPBAIXATED,:IDHABIBOLE,:CDSERIEENTRSAG,
                                            :CDFORNECEDSAG,:CDTIPOOPERSAG,:CDTPCTPAGARSAG,:IDUTILPADRBOLHAB,
                                            :IDUTIAUTDESP,:IDEXTELACALAJUBX,:CDTPCREDESTBANC,:IDUTLNFDEVOL,
                                            :IDUTVISUBOLOPEL,:CDOPEPERVISUBOL,:QTDIAANTBAIP,:QTDIAAPOBAIP,
                                            :QTDIAANTBOLP,:QTDIAANTLANP,:QTDIAAPOLANP,:QTDIAAPOBOLP,:NRORG)";
                     
            $std = $this->connection->prepare($sql);
            $std->execute($paramsGeralPag);
    }
    
    public function atualizaRegistro($params){
        $sql = "UPDATE GERAL_PAG SET CDAJMULTAPAG =: CDAJMULTAPAG,
                    	             CDAJMORAPAG =:CDAJMORAPAG,
                    	             CDAJACREPAG =:CDAJACREPAG,
                    	             CDAJDESCPAG =:CDAJDESCPAG,
                                     CDTPBXANTAUTO =:CDTPBXANTAUTO,
                                     CDAJUANTAUTO =:CDAJUANTAUTO,
                                     CDTPBXCREDCONT =:CDTPBXCREDCONT,
                                     CDTPBAIXADOC =:CDTPBAIXADOC,
                                     CDTPBAIXATED =:CDTPBAIXATED,
                                     IDHABIBOLE =:IDHABIBOLE,
                                     CDSERIEENTRSAG =:CDSERIEENTRSAG,
                                     CDFORNECEDSAG =:CDFORNECEDSAG,
                                     CDTIPOOPERSAG =:CDTIPOOPERSAG,
                                     CDTPCTPAGARSAG =:CDTPCTPAGARSAG,
                                     IDUTILPADRBOLHAB =:IDUTILPADRBOLHAB,
                                     IDUTIAUTDESP =:IDUTIAUTDESP,
                                     IDEXTELACALAJUBX =:IDEXTELACALAJUBX,
                                     CDTPCREDESTBANC =:CDTPCREDESTBANC,
                                     IDUTLNFDEVOL =:IDUTLNFDEVOL,
                                     IDUTVISUBOLOPEL =:IDUTVISUBOLOPEL,
                                     CDOPEPERVISUBOL =:CDOPEPERVISUBOL,
                                     QTDIAANTBAIP =:QTDIAANTBAIP,
                                     QTDIAAPOBAIP =:QTDIAAPOBAIP,
                                     QTDIAANTBOLP =:QTDIAANTBOLP,
                                     QTDIAANTLANP =:QTDIAANTLANP,
                                     QTDIAAPOLANP =:QTDIAAPOLANP,
                                     QTDIAAPOBOLP =:QTDIAAPOBOLP
                WHERE CDGERALPAG =:CDGERALPAG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
    }
}