<?php

namespace Teknisa\CADFIN\Factories;

use Doctrine\ORM\EntityManager;

class Ger08300BancoFactory {
    #default service
    protected $connection;

    /* **************************************************
     * Construtor da Factory.
     *
     * @param EntityManager $entityManager
     */
    
    public function __construct(EntityManager $entityManager) {
        #initializes default service
        $this->connection = $entityManager->getConnection();
    }
    
    public function getBancos($params) {
        $sql = "SELECT * FROM BANCO WHERE 
                (NRORG = :NRORG OR NRORG = '0') 
                AND (CDBANCO LIKE :CDBANCO OR :TCDBANCO = 'T')
                AND (upper(NMBANCO) LIKE upper(:NMBANCO) OR :TNMBANCO = 'T') ORDER BY CDBANCO ASC";


        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function saveCNABdata($params) {
        $sql = "update EMPRBANC
                set
                  CDEMPBANCPAG = :CDEMPBANCPAG,
                  CDEMPBANCREC = :CDEMPBANCREC,
                  CDCARTCOBR = :CDCARTCOBR,
                  CDINS1COBR = :CDINS1COBR,
                  CDINS2COBR = :CDINS2COBR,
                  QTDIAPROTEST = :QTDIAPROTEST,
                  CDDIAPROTEST = :CDDIAPROTEST,
                  IDIMPRBOLETO = :IDIMPRBOLETO,
                  TXMENSBOLETO = :TXMENSBOLETO,
                  IDCARTCOBR = :IDCARTCOBR,
                  IDFORMCADBANC = :IDFORMCADBANC,
                  IDLAYEXTBANCO = :IDLAYEXTBANCO,
                  NRVARIACARTCOB = :NRVARIACARTCOB,
                  IDLAYOUTCNAB = :IDLAYOUTCNAB,
                  CDFORNECED = :CDFORNECED,
                  CDTPBAIXAPAG = :CDTPBAIXAPAG,
                  CDREDUCONT = :CDREDUCONT,
                  IDPADRAGENCNABPAG = :IDPADRAGENCNABPAG,
                  IDPADRCNABREC = :IDPADRCNABREC,
                  IDPADRCNABPAG = :IDPADRCNABPAG,
                  CDCOMPROMISSO = :CDCOMPROMISSO,
                  QTDIADEVOL = :QTDIADEVOL,
                  CDDIADEVOL = :CDDIADEVOL,
                  IDCONSDTENVREM = :IDCONSDTENVREM
                where
                  CDEMPRESA = :CDEMPRESA and
                  CDBANCO = :CDBANCO";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

}