<?php

namespace Teknisa\CADFIN\Factories;

use Doctrine\ORM\EntityManager;


class Ger70000TipoDePagamentoFactory {

    protected $entityManager;
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
        $this->connection = $entityManager->getConnection();
    }

    public function saveTipPag($paramInsert){
        
        $sql = "INSERT INTO TIPOPAGTO ( CDTIPOPAGTO,
                                        NMTIPOPAGTO,
                                        IDTIPOPAGTO,
                                        NRORG,
                                        IDATIVO) 
                              VALUES (  :CDTIPOPAGTO,
                                        :NMTIPOPAGTO,
                                        :IDTIPOPAGTO,
                                        :NRORG,
                                        :IDATIVO)";

        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        // Executa o statement com os paràmetros passados.
        $std->execute($paramInsert);
    }
    
    public function updateTipPag($paramsUpdate) {
        $sql = "UPDATE TIPOPAGTO
                SET
                  NMTIPOPAGTO = :NMTIPOPAGTO,
                  IDTIPOPAGTO = :IDTIPOPAGTO,
                  NRORG       = :NRORG,
                  IDATIVO     = :IDATIVO
                WHERE
                  CDTIPOPAGTO = :CDTIPOPAGTO
                  AND NRORG = :NRORG";

        $std = $this->connection->prepare($sql);
        $std->execute($paramsUpdate);
    }
    
    public function deleteTipPag($paramsDelete) {
        $sql = "DELETE FROM TIPOPAGTO 
                    WHERE CDTIPOPAGTO = :CDTIPOPAGTO
                    AND NRORG = :NRORG";

        $std = $this->connection->prepare($sql);
        $std->execute($paramsDelete);
    }
    
    public function getTipoPagamento($getTipoPagamento) {
        $sql = "SELECT * FROM TIPOPAGTO 
                    WHERE CDTIPOPAGTO = :CDTIPOPAGTO";

        $std = $this->connection->prepare($sql);
        $std->execute($getTipoPagamento);
        return $std->fetchAll();
    }

}