<?php
namespace Teknisa\CADFIN\Services;

use Teknisa\Libs\Util\Environment;
use Teknisa\CADFIN\Factories\Ger70000TipoDePagamentoFactory;

class Ger70000TipoDePagamentoService{

	protected $environment;
	protected $entityManager;

	public function __construct(Environment $environment, $Ger70000TipoDePagamentoFactory){
		$this->environment = $environment;
		$this->Ger70000TipoDePagamentoFactory = $Ger70000TipoDePagamentoFactory;

	}
    
	public function saveTipPag($row){
	    try{
            $param = array(
                "CDTIPOPAGTO" => $row["CDTIPOPAGTO"],
            );
            $tipoDePagamento = $this->Ger70000TipoDePagamentoFactory->getTipoPagamento($param);
            
            $paramInsert = array(
                "CDTIPOPAGTO" => $row["CDTIPOPAGTO"],
                "NMTIPOPAGTO" => $row["NMTIPOPAGTO"],
                "IDTIPOPAGTO" => $row["IDTIPOPAGTO"],
                "NRORG"=>$row["NRORG"],
                "IDATIVO"=>"S"
            );
            
            if($tipoDePagamento){
                throw new \Exception('Código de tipo de pagamento já existe');
            }else{
              return $this->Ger70000TipoDePagamentoFactory->saveTipPag($paramInsert);
            }
            
	    }
	    catch (\Exception $e) {
            throw $e;
		}
	}
	
	public function updateTipPag($row){
	    try{
	        $paramsUpdate = array(
                "CDTIPOPAGTO" => $row["CDTIPOPAGTO"],
                "NMTIPOPAGTO" => $row["NMTIPOPAGTO"],
                "IDTIPOPAGTO" => $row["IDTIPOPAGTO"],
                "NRORG"=>$row["NRORG"],
                "IDATIVO"=>"S"
            );
            
		$this->Ger70000TipoDePagamentoFactory->updateTipPag($paramsUpdate);
	    }
	    catch (\Exception $e) {
            throw new \Exception($e->getMessage(), $e->getCode());
		}
	}
	public function deleteTipPag($row){
	    try{
	        $paramsDelete = array(
                "CDTIPOPAGTO" => $row["CDTIPOPAGTO"],
                "NRORG"=>$row["NRORG"]
            );
		$this->Ger70000TipoDePagamentoFactory->deleteTipPag($paramsDelete);
	    }
	    catch (\Exception $e) {
            throw new \Exception('Erro ao deletar');
		}
	}
}