create or replace
PROCEDURE ETL_ESTOQUE
        (P_DTINI      IN DATE,
         P_DTFINA     IN DATE)
IS
   V_DTFIM                  DATE;
   V_DTINI                  DATE;
   V_ESTOQUE_INICIAL        FLOAT NOT NULL  := 0;
   V_ESTOQUE_FINAL          FLOAT NOT NULL  := 0;
   V_DIAS_ESTOQUE           FLOAT NOT NULL  := 0;
   V_QTINVENTARIADA         FLOAT NOT NULL  := 0;
   V_QTESTOQUE              FLOAT NOT NULL  := 0;
   V_VRESTOQUE              FLOAT NOT NULL  := 0;
   V_VRESTUNIT              FLOAT NOT NULL  := 0;
   V_DIA                    VARCHAR2(02);
   V_MES                    VARCHAR2(02);
   V_ANO                    VARCHAR2(04);
   V_BIM                    VARCHAR2(06);
   V_TRI                    VARCHAR2(06);
   V_SEM                    VARCHAR2(06);
   V_ZERO                   NUMBER := 0;
   V_CONT                   NUMBER := 0;
   V_TIPOCUSTOEST           VARCHAR2(02);
   V_PRXMOVI                VARCHAR2(20);
   V_NIVEL                  FLOAT;
   V_PRODINI                PRODUTO.CDARVPROD%TYPE;
   V_PRODFIN                PRODUTO.CDARVPROD%TYPE;
   V_QTDEMOVIMENTADA        RELAT_TOTAMOVI.VRQTDERETIME%TYPE;
   V_QTDEDIASNAOUTEIS       FLOAT;
   V_RETIRADAMEDIADIA       FLOAT;
BEGIN
   V_MES  :=  TO_CHAR(P_DTINI,'MM');
   V_ANO  :=  TO_CHAR(P_DTINI,'YYYY');
   DELETE FROM  ETL_RESUESTO
   WHERE        CDANOBI  >= V_ANO
   AND          CDMESBI  >= V_MES;
   COMMIT;
   V_DTINI := TO_DATE('01'||TO_CHAR(P_DTINI,'MMYYYY'),'DDMMYYYY');
   SELECT LENGTH(MAX(CDARVPROD)), MIN(CDARVPROD), MAX(CDARVPROD)
     INTO V_NIVEL, V_PRODINI, V_PRODFIN
     FROM PRODUTO
    WHERE PRODUTO.CDPRODESTO IS NOT NULL;
   WHILE (V_DTINI <= P_DTFINA)
   LOOP
      V_DTFIM := LAST_DAY( V_DTINI);
      V_MES :=  TO_CHAR(V_DTFIM,'MM');
      V_ANO :=  TO_CHAR(V_DTFIM,'YYYY');
      V_BIM :=  TO_CHAR(TRUNC((V_MES - 1) / 2) + 1)||' Bim';
      V_TRI :=  TO_CHAR(TRUNC((V_MES - 1) / 3) + 1)||' Tri';
      V_SEM :=  TO_CHAR(TRUNC((V_MES - 1) / 6) + 1)||' Sem';
      FOR C_ETL IN
         (SELECT
                F.CDFILIAL,        F.CDAREAGERE,        F.CDSEGMER,
                F.CDEMPRESA,       F.CDSUPERVISOR,      F.DTINICIALBI,
                F.CDGOPERAC,       P.DTPROCESSA,        P.IDUTILALMOX, P.CDALMOXARIFE
          FROM
                FILIAL F, PARAMFILIAL P
          WHERE
                P.CDFILIAL = F.CDFILIAL
          AND   F.IDFUNCAOFILI IS NULL
          AND   F.DTINICIALBI IS NOT NULL
          )
      LOOP
             BEGIN
               SELECT NVL (P.CDTIPCUSTEST, '03')
                 INTO V_TIPOCUSTOEST
                 FROM PARAMFILIAL P
                WHERE P.CDFILIAL = C_ETL.CDFILIAL;
               EXCEPTION
                     WHEN OTHERS THEN
                     V_TIPOCUSTOEST := '03';
             END;
         IF TO_DATE('01'||TO_CHAR(C_ETL.DTINICIALBI,'MMYYYY'),'DDMMYYYY') <= V_DTINI THEN
            V_QTDEDIASNAOUTEIS:=0;
            SELECT COUNT(1)
              INTO V_QTDEDIASNAOUTEIS
             FROM FERIFILI
            WHERE CDFILIAL = C_ETL.CDFILIAL
              AND DTFERIFILI BETWEEN V_DTINI AND V_DTFIM;
            NOVO_CODIGO('MOVIESTOQUE', V_PRXMOVI);
            V_PRXMOVI := SUBSTR(V_PRXMOVI,11,10);
            IF C_ETL.IDUTILALMOX = 'S' THEN
               MOVIMENTACAO_ESTOQUE(C_ETL.CDFILIAL, C_ETL.CDALMOXARIFE, '', '', V_NIVEL, V_DTINI, V_DTFIM, V_PRODINI, V_PRODFIN, 1, V_TIPOCUSTOEST, V_PRXMOVI);
            ELSE
               MOVIMENTACAO_ESTOQUE(C_ETL.CDFILIAL, ' ', ' ', ' ', V_NIVEL, V_DTINI, V_DTFIM, V_PRODINI, V_PRODFIN, 1, V_TIPOCUSTOEST, V_PRXMOVI);
            END IF;
            FOR C_ESTOQUE IN
               (SELECT B.QTESTDIACON,     B.VRESTDIACON,    B.CDFILIAL,
                       B.CDPRODUTO,       P.NMPRODUTO
                  FROM POSESTCONS B, PRODUTO P
                 WHERE B.CDFILIAL     = C_ETL.CDFILIAL
                   AND B.CDPRODUTO    = P.CDPRODUTO
                   AND B.QTESTDIACON <> 0
                   AND B.DTPOSESTCON  = DTPOSICAO_POSESTCONS(B.CDFILIAL, B.CDPRODUTO, V_DTFIM + 1))
            LOOP

               BEGIN
                  SELECT SUM(P.QTESTDIACON * CUSTO_PRODUTO(C_ETL.CDFILIAL, P.CDPRODUTO, V_TIPOCUSTOEST,
                         TO_DATE( V_DTINI - 1), TRUNC(SYSDATE)))
                    INTO V_ESTOQUE_INICIAL
                    FROM POSESTCONS P
                   WHERE P.CDFILIAL    = C_ETL.CDFILIAL
                     AND P.CDPRODUTO   = C_ESTOQUE.CDPRODUTO
                     AND P.QTESTDIACON <> 0
                     AND P.DTPOSESTCON = DTPOSICAO_POSESTCONS(P.CDFILIAL, P.CDPRODUTO, V_DTINI + 1);
               EXCEPTION
                  WHEN OTHERS THEN
                     V_ESTOQUE_INICIAL := V_ZERO;
               END;

               BEGIN
                  SELECT SUM(P.QTESTDIACON * CUSTO_PRODUTO(C_ETL.CDFILIAL, P.CDPRODUTO, V_TIPOCUSTOEST,
                         TO_DATE(V_DTFIM), TRUNC(SYSDATE)))
                    INTO V_ESTOQUE_FINAL
                    FROM POSESTCONS P
                   WHERE P.CDFILIAL    =  C_ETL.CDFILIAL
                     AND P.CDPRODUTO   =  C_ESTOQUE.CDPRODUTO
                     AND P.QTESTDIACON <> 0
                     AND P.DTPOSESTCON = DTPOSICAO_POSESTCONS(P.CDFILIAL, P.CDPRODUTO, V_DTFIM + 1);
                EXCEPTION
                     WHEN OTHERS THEN
                        V_ESTOQUE_FINAL :=  V_ZERO;
               END;

               SELECT SUM(QTLANCAMENTO)
                 INTO V_QTDEMOVIMENTADA
               FROM RELAT_MOVIEST
               WHERE NRRELATMOVI = V_PRXMOVI
                 AND CDPRODMOVIEST = C_ESTOQUE.CDPRODUTO
                 AND CDFILIMOVIEST = C_ETL.CDFILIAL
                 AND IDTIPOMOVIEST = '3';
               IF ((V_DTFIM - V_DTINI) - V_QTDEDIASNAOUTEIS) > 0 THEN
                  V_RETIRADAMEDIADIA := V_QTDEMOVIMENTADA/((V_DTFIM - V_DTINI) - V_QTDEDIASNAOUTEIS);
               ELSE
                  V_RETIRADAMEDIADIA := V_QTDEMOVIMENTADA/30;
               END IF;
               V_RETIRADAMEDIADIA := (V_RETIRADAMEDIADIA * CUSTO_PRODUTO(C_ETL.CDFILIAL, C_ESTOQUE.CDPRODUTO, V_TIPOCUSTOEST, TO_DATE(V_DTFIM), TRUNC(SYSDATE)));
               IF (V_ESTOQUE_FINAL > 0) AND (V_RETIRADAMEDIADIA > 0) THEN
                  V_DIAS_ESTOQUE := TRUNC(V_ESTOQUE_FINAL/V_RETIRADAMEDIADIA);
               ELSE
                  V_DIAS_ESTOQUE := 0;
               END IF;

               V_QTINVENTARIADA := ((V_ESTOQUE_FINAL) - (V_ESTOQUE_INICIAL));
               IF (C_ESTOQUE.QTESTDIACON <>0) OR  (C_ESTOQUE.VRESTDIACON<>0)   THEN
                  INSERT INTO  ETL_RESUESTO
                     ( CDSUPERVISOR,   --> SUPERVISOR     
                       CDGOPERAC,      --> GERENTE OPERACIONAL    
                       CDEMPRESA,      --> EMPRESA
                       CDFILIAL,       --> FILIAL
                       CDAREAGERE,     --> REGIONAL
                       CDSEGMER,       --> SEGMENTO DE MERCADO
                       CDPRODUTO,      --> PRODUTO
                       CDANOBI,        --> ANO
                       CDMESBI,        --> MES
                       BIETLEST,       --> BIMESTRE
                       TRETLEST,       --> TRIMESTRE   
                       SEETLEST,       --> SEMESTRE
                       QTESTOETLEST,   --> QUATIDADE EM ESTOQUE
                       QTINVENTETLEST, --> QUANTIDADE INVENTARIADA(ESTOQUE FINAL-INICIAL)  
                       QTDIAESTETLEST, --> DIAS EM ESTOQUE (ESTOQUE FINAL/MEDIA DAS RETIRADAS DOS DIAS TEIS)
                       VRTOTESTETLEST, --> VALOR TOTAL EM ESTOQUE
                       DSDTPROCETLESTO,--> DATA DE PROCESSAMENTO DA FILIAL
                       VRUNIESTETLEST  --> VALOR UNITRIO DO PRODUTO
                     )
                  VALUES
                    (  C_ETL.CDSUPERVISOR,    --> SUPERVISOR 
                       C_ETL.CDGOPERAC,       --> GERENTE OPERACIONAL
                       C_ETL.CDEMPRESA,       --> EMPRESA
                       C_ETL.CDFILIAL,        --> FILIAL
                       C_ETL.CDAREAGERE,      --> REGIONAL
                       C_ETL.CDSEGMER,        --> SEGMENTO DE MERCADO
                       C_ESTOQUE.CDPRODUTO,   --> PRODUTO
                       V_ANO,                 --> ANO
                       V_MES,                 --> MES
                       V_BIM,                 --> BIMESTRE
                       V_TRI,                 --> TRIMESTRE
                       V_SEM,                 --> SEMESTRE
                       C_ESTOQUE.QTESTDIACON, --> QUATIDADE EM ESTOQUE
                       V_QTINVENTARIADA,      --> QUANTIDADE INVENTARIADA(ESTOQUE FINAL-INICIAL)
                       V_DIAS_ESTOQUE,        --> DIAS EM ESTOQUE (ESTOQUE FINAL/MEDIA DAS RETIRADAS DOS DIAS TEIS)
                       (C_ESTOQUE.QTESTDIACON*CUSTO_PRODUTO(C_ETL.CDFILIAL, C_ESTOQUE.CDPRODUTO, V_TIPOCUSTOEST, TO_DATE(V_DTFIM), TRUNC(SYSDATE))), --> VALOR TOTAL EM ESTOQUE
                       TO_CHAR(C_ETL.DTPROCESSA, 'DD/MM/YYYY'), --> DATA DE PROCESSAMENTO DA FILIAL
                       CUSTO_PRODUTO(C_ETL.CDFILIAL, C_ESTOQUE.CDPRODUTO, V_TIPOCUSTOEST, TO_DATE(V_DTFIM), TRUNC(SYSDATE))--> VALOR UNITRIO DO PRODUTO
                     );
                  V_CONT := V_CONT + 1;
                  IF V_CONT >= 300 THEN
                      COMMIT;
                      V_CONT := 0;
                  END IF;
               END IF;
            END LOOP;
         END IF;
      END LOOP;
      COMMIT;
      V_DTINI := ADD_MONTHS (V_DTINI, 1);
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ETL_ESTOQUE','6.49.046'); END;
/
