import { ZdPage } from '@zeedhi/vue';
import { ZdFramePage } from '@zeedhi/vuetify';

const routes = [
  {
    path: '/auth/login',
    name: 'login',
    component: ZdPage,
    props: {
      path: 'login',
      local: true,
    },
  },
  {
    path: '/',
    name: 'home',
    component: ZdPage,
    props: () => ({
      path: 'home',
      local: true,
    }),
  },
  {
    path: '/modules/:module/:page',
    name: 'microservice',
    component: () => import('../views/Microservice.vue'),
  },
  {
    path: '*',
    component: ZdPage,
    props: {
      path: 'notfound',
      local: true,
    },
  },
  {
    path: '/nome_que_aparecera_na_url',
    name: 'Nome da Tela',
    component: ZdFramePage,
    props: {
        type: 'post',
        params: {
            jsonPath: 'nome_arquivo',
            routePath: '/nome_na_rota_menu',
        },
    },
  },
];

export default routes;
